 '  CombID.inc
 '  includes for getting the combined IDs of  HDD serial, MB Serial , Bios Rel Date
 '  MAC address and GUID

     GLOBAL LWa  AS STRING
       GLOBAL LWb   AS STRING
       GLOBAL LWc   AS STRING
       GLOBAL LWd   AS STRING
       GLOBAL LWe  AS STRING
       GLOBAL LWf    AS STRING
       GLOBAL LWg   AS STRING
       GLOBAL LWh   AS STRING
       GLOBAL LWi   AS STRING
       GLOBAL LWj   AS STRING
       GLOBAL LWk   AS STRING
       GLOBAL LWl    AS STRING

       GLOBAL LWm   AS STRING
       GLOBAL LWn    AS STRING
       GLOBAL LWo    AS STRING
       GLOBAL LWp    AS STRING
       GLOBAL LWq    AS STRING
       GLOBAL LWr    AS STRING

       GLOBAL LWs   AS STRING
       GLOBAL LWt    AS STRING
       GLOBAL LWu   AS STRING
       GLOBAL LWv   AS STRING
       GLOBAL LWw  AS STRING
       GLOBAL LWx   AS STRING
       GLOBAL LWy   AS STRING
       GLOBAL LWz   AS STRING

       GLOBAL BSpc   AS STRING
       GLOBAL scomma   AS STRING
       GLOBAL suscore   AS STRING



  %NORMAL = 0
  %USEMACROS = 1

%KEY_WOW64_64KEY               = &H0100???
%Date_1970_01_01               = 116444736000000000

%OUTPUT_DATA_SIZE              = %IDENTIFY_BUFFER_SIZE + 16

%IDE_ID_FUNCTION               = &HEC
%IDE_EXECUTE_SMART_FUNCTION    = &HB0
%SMART_CYL_LOW                 = &H4F
%SMART_CYL_HI                  = &HC2

%SMART_ENABLE_SMART_OPERATIONS = &HD8
%PRE_FAILURE_WARRANTY          = &H1
%ON_LINE_COLLECTION            = &H2
%DFP_GET_VERSION               = &H74080
%DFP_SEND_DRIVE_COMMAND        = &H7C084
%DFP_RECEIVE_DRIVE_DATA        = &H7C088

TYPE IDSECTOR 'The following struct defines the IDENTIFY buffer. diskid32.cpp
  wGenConfig                 AS INTEGER
  wNumCyls                   AS INTEGER
  wReserved                  AS INTEGER
  wNumHeads                  AS INTEGER
  wBytesPerTrack             AS INTEGER
  wBytesPerSector            AS INTEGER
  wSectorsPerTrack           AS INTEGER
  wVendorUnique(0 TO 2)      AS INTEGER
  sSerialNumber(0 TO 19)     AS BYTE
  wBufferType                AS INTEGER
  wBufferSize                AS INTEGER
  wECCSize                   AS INTEGER
  sFirmwareRev(0 TO 7)       AS BYTE
  sModelNumber(0 TO 39)      AS BYTE
  wMoreVendorUnique          AS INTEGER
  wDoubleWordIO              AS INTEGER
  wCapabilities              AS INTEGER
  wReserved1                 AS INTEGER
  wPIOTiming                 AS INTEGER
  wDMATiming                 AS INTEGER
  wBS                        AS INTEGER
  wNumCurrentCyls            AS INTEGER
  wNumCurrentHeads           AS INTEGER
  wNumCurrentSectorsPerTrack AS INTEGER
  ulCurrentSectorCapacity    AS LONG
  wMultSectorStuff           AS INTEGER
  ulTotalAddressableSectors  AS LONG
  wSingleWordDMA             AS INTEGER
  wMultiWordDMA              AS INTEGER
  bReserved(0 TO 127)        AS BYTE
END TYPE

TYPE ATTR_DATA
  AttrID           AS BYTE
  AttrName(0 TO 7) AS BYTE
  AttrValue        AS BYTE
  ThresholdValue   AS BYTE
  WorstValue       AS BYTE
  StatusFlags      AS BYTE
END TYPE

TYPE DRIVE_INFO
  bDriveType            AS BYTE
  SerialNumber(0 TO 19) AS BYTE
  Model(0 TO 39)        AS BYTE
  FirmWare(0 TO 7)      AS BYTE
  Cilinders             AS LONG
  Heads                 AS LONG
  SecPerTrack           AS LONG
  BytesPerSector        AS LONG
  BytesperTrack         AS LONG
  NumAttributes         AS BYTE
  Attributes(0 TO 1)    AS ATTR_DATA
END TYPE




TYPE IP_ADAPTER_INF
  pNext               AS IP_ADAPTER_INFO PTR
  ComboIndex          AS DWORD
  AdapterName         AS STRING * (%MAX_ADAPTER_NAME_LENGTH + 4)
  Description         AS STRING * (%MAX_ADAPTER_DESCRIPTION_LENGTH + 4)
  AddressLength       AS DWORD
  Address(0 TO %MAX_ADAPTER_ADDRESS_LENGTH - 1) AS BYTE
  Index               AS DWORD
  uType               AS DWORD
  DhcpEnabled         AS DWORD
  CurrentIpAddress    AS IP_ADDR_STRING PTR
  IpAddressList       AS IP_ADDR_STRING
  GatewayList         AS IP_ADDR_STRING
  DhcpServer          AS IP_ADDR_STRING
  HaveWins            AS LONG
  PrimaryWinsServer   AS IP_ADDR_STRING
  SecondaryWinsServer AS IP_ADDR_STRING
  LeaseObtained       AS LONG
  LeaseExpires        AS LONG
END TYPE


 '=====================================================
 ' get the combined IDs
 ' all these IDs are same as those obtained via C#
 SUB GitCombID( stRelDate AS STRING, stHDserial AS STRING ,stVolsn AS STRING, _
                stMBSNumb AS  STRING , stMac AS  STRING)



    '  the HDD Volume serial number of drive C: (which can change after the drive is formatted)
    '    https://www.powerbasic.com/support/pbforums/showthread.php?t=45991
    LOCAL VolSerial AS DWORD
    GETVOLUMEINFORMATION CHR$(67)+CHR$(58)+ CHR$(92) , "", 0, VolSerial, 0, 0, "", 0
    stVolsn=HEX$(VolSerial,8)



    ' Harddisk Serial   --------------------------------------------
    stHDserial =  TRIM$(GetDriveSerial())
    stHDserial =  TRIM$(  stHDserial, ANY CHR$(0) + CHR$(32)+ CHR$(10) + CHR$(13)+ CHR$(9))
   ' Limit the length of the HD serial #
   ' since too long will entail more resources for encryption
     IF LEN(stHDserial) > 30 THEN
         stHDserial  =  LEFT$(stHDserial,30)
     END IF




 ' Obtain the MainBoard Info  ------------------------------------------
  LOCAL sMother AS STRING
  DIM pPos AS LOCAL INTEGER
  DIM sPos AS LOCAL INTEGER
  DIM sLen  AS LOCAL INTEGER

   sMother = MotherInfo
   pPos = INSTR(1,smother,"P:")
   sPos = INSTR(1,smother,"S:")
   sLen = LEN(smother)
   stMBSNumb = TRIM$(MID$(smother,sPos+2,sLen - sPos -2))
   stMBSNumb = TRIM$(  stMBSNumb,ANY CHR$(0) + CHR$(32)+ CHR$(10) + CHR$(13)+ CHR$(9))

   ' Limit the length of the MB product name and Serial #
   ' since too long will entail more resources for encryption
     IF LEN(stMBSNumb) > 30 THEN
         stMBSNumb  =  LEFT$(stMBSNumb,30)
     END IF




   ' get the MAC address   ---------------------------
   ' use the first Adapter only
  DIM dPos AS LOCAL INTEGER
  DIM mPos AS LOCAL INTEGER
  DIM nPos AS LOCAL INTEGER

   dPos = INSTR(1,AdaptersInfoGet,"D:1")
   mPos = INSTR(1,AdaptersInfoGet,"M:1")
   nPos = INSTR(1,AdaptersInfoGet,"N:1")
   sLen = LEN(AdaptersInfoGet)

   stMac = TRIM$(MID$(AdaptersInfoGet,mPos+3,nPos - mPos -3))
   stMac = TRIM$(stMac,ANY CHR$(0) + CHR$(32)+ CHR$(10) + CHR$(13)+ CHR$(9))
   ' Limit the length of the adapter description , MAC and name
   ' since too long will entail more resources for encryption
     IF LEN(stMac) > 25 THEN
         stMac  =  LEFT$(stMac,25)
     END IF
   ' Make it uppercase and remove dashes to match results in C#
      stMac = UCASE$(stMac)
      stMac = TrimAllDash(stMac)


   ' Obtain the BIOS Release Date ---------------------------------------------------------
  DIM rPos AS LOCAL INTEGER
  DIM bPos AS LOCAL INTEGER
    rPos = INSTR(1,Biosinfo,"R:")
    bPos = INSTR(1,Biosinfo,"B:")
    sLen = LEN(Biosinfo)
    stRelDate = TRIM$(MID$(Biosinfo,rPos+2,bPos - rPos -2))
    stRelDate = TRIM$( stRelDate, ANY CHR$(0) + CHR$(32)+ CHR$(10) + CHR$(13)+ CHR$(9))


  END SUB



 '======================================
 ' Removes all in between dashes from a given string
  FUNCTION TrimAllDash( vstring AS STRING)AS STRING
    IF LEN(TRIM$(vstring)) = 0 THEN
        FUNCTION = ""
    ELSE
        FUNCTION = TRIM$(REMOVE$(vString,ANY "-"))
    END IF

  END   FUNCTION







'===============================================================
'  GetCpuSerial - Returns serial no on Intel CPU
'  http://www.garybeene.com/powerbasic/thread_014065.htm
'  However it is not in the same format as those obtained by C#
FUNCTION GetCpuSerial()  AS STRING
LOCAL t AS DWORD, m AS DWORD, b AS DWORD
!mov eax,1
!cpuid
!mov t,eax
!mov eax,3
!cpuid
!mov m,edx
!mov b,ecx
FUNCTION = HEX$(HIWRD(t),4) &  HEX$(LOWRD(t),4) &  HEX$(HIWRD(m),4) &  _
HEX$(LOWRD(m),4) &  HEX$(HIWRD(b),4) &  HEX$(LOWRD(b),4)

END FUNCTION


'===============================================================
' CPUMfc - Returns manufacturer name string of CPU
FUNCTION CPUMfc () AS STRING
DIM lID AS LOCAL STRING * 12
! xor eax,eax
! cpuid
! push edi
! lea edi, lID
! mov[edi],ebx
! mov[edi+4],edx
! mov[edi+8],ecx
! pop edi
FUNCTION = lID
END FUNCTION





   '______________________________________________________________________________

FUNCTION SmartCheckEnabled(BYVAL hDrive AS LONG, DriveNumber AS BYTE) AS LONG
 'Send a SMART_ENABLE_SMART_OPERATIONS command to the drive
 LOCAL SendCmdIn       AS SENDCMDINPARAMS
 LOCAL SendCmdOut      AS SENDCMDOUTPARAMS
 LOCAL BytesReturned   AS LONG
 LOCAL RetVal          AS LONG

 SendCmdIn.cBufferSize                  = 0
 SendCmdIn.irDriveRegs.bFeaturesReg     = %SMART_ENABLE_SMART_OPERATIONS
 SendCmdIn.irDriveRegs.bSectorCountReg  = 1
 SendCmdIn.irDriveRegs.bSectorNumberReg = 1
 SendCmdIn.irDriveRegs.bCylLowReg       = %SMART_CYL_LOW
 SendCmdIn.irDriveRegs.bCylHighReg      = %SMART_CYL_HI
 SendCmdIn.irDriveRegs.bDriveHeadReg    = &HA0

 IF Nt4OrNewer = 0 THEN
   SendCmdIn.irDriveRegs.bDriveHeadReg =  _
           SendCmdIn.irDriveRegs.bDriveHeadReg OR ((DriveNumber AND 1) * 16)
 END IF
 SendCmdIn.irDriveRegs.bCommandReg = %IDE_EXECUTE_SMART_FUNCTION
 SendCmdIn.bDriveNumber            = DriveNumber
 RetVal = DeviceIoControl(hDrive, %DFP_SEND_DRIVE_COMMAND, BYVAL VARPTR(SendCmdIn), _
                          SIZEOF(SENDCMDINPARAMS) - 1, BYVAL VARPTR(SendCmdOut), _
                           SIZEOF(SENDCMDOUTPARAMS) - 1, _
                          BytesReturned, BYVAL 0&)
 FUNCTION = RetVal

END FUNCTION

 '______________________________________________________________________________

FUNCTION Nt4OrNewer() AS LONG 'Returns True if running Windows NT4 or later
 LOCAL OsVersionInf AS OSVERSIONINFO

 OsVersionInf.dwOSVersionInfoSize = SIZEOF(OSVERSIONINFO)
 IF GetVersionEx(OsVersionInf) = 1 THEN
   FUNCTION = (OsVersionInf.dwPlatformId = %VER_PLATFORM_WIN32_NT) AND(OsVersionInf.dwMajorVersion >= 4)
 END IF

END FUNCTION


'______________________________________________________________________________

FUNCTION VistaOrNewer() AS LONG 'True if running Vista or newer
 LOCAL OsVersionInf AS OSVERSIONINFO

 OsVersionInf.dwOSVersionInfoSize = SIZEOF(OSVERSIONINFO)
 GetVersionEx(OsVersionInf)
 IF (OsVersionInf.dwMajorVersion >= 6) THEN FUNCTION = %TRUE 'Xp is 5.1, Vista is 6.0

END FUNCTION







'______________________________________________________________________________

FUNCTION SmartGetVersion(BYVAL hDrive AS LONG) AS DWORD
 LOCAL GetVersionOut AS GETVERSIONINPARAMS
 LOCAL BytesReturned AS LONG

 FUNCTION = DeviceIoControl(hDrive, %DFP_GET_VERSION, BYVAL 0&, 0, _
              BYVAL VARPTR(GetVersionOut), _
              SIZEOF(GETVERSIONINPARAMS), BytesReturned, BYVAL 0&)

END FUNCTION


'______________________________________________________________________________

FUNCTION GetDriveInfoXP(DriveNumber AS BYTE, DriveInf AS drive_info) AS LONG
 LOCAL hDrive AS LONG
 LOCAL RetVal AS BYTE

 hDrive = SmartOpen(DriveNumber)
 IF hdrive <> %INVALID_HANDLE_VALUE THEN
   RetVal = SmartGetVersion(hDrive)
   IF RetVal = %TRUE THEN
     DriveInf.bDriveType = 0
     DriveInf.NumAttributes = 0
     RetVal = SmartCheckEnabled(hDrive, DriveNumber)
     IF RetVal = %TRUE THEN
       RetVal = IdentifyDrive(hDrive, %IDE_ID_FUNCTION, DriveNumber, DriveInf)
       IF RetVal THEN
         FUNCTION = %TRUE
       END IF
     END IF
   END IF
 END IF
 CloseHandle(hDrive)

END FUNCTION

  '______________________________________________________________________________

FUNCTION SmartOpen(DriveNumber AS BYTE) AS DWORD
 'Open SMART to allow DeviceIoControl communications and return SMART handle
 LOCAL hDevice AS DWORD
     BSpc = CHR$(32)
        scomma = CHR$(44)
        suscore = CHR$(95)



       LWa   = CHR$(97)
       LWb    = CHR$(98)
       LWc    = CHR$(99)
       LWd    = CHR$(100)
       LWe   = CHR$(101)
       LWf     = CHR$(102)
       LWg    = CHR$(103)
       LWh    = CHR$(104)
       LWi    = CHR$(105)
       LWj    = CHR$(106)
       LWk    = CHR$(107)
       LWl     = CHR$(108)

       LWm    = CHR$(109)
       LWn     = CHR$(110)
       LWo     = CHR$(111)
       LWp     = CHR$(112)
       LWq     = CHR$(113)
       LWr     = CHR$(114)

       LWs    = CHR$(115)
       LWt     = CHR$(116)
       LWu    = CHR$(117)
       LWv    = CHR$(118)
       LWw   = CHR$(119)
       LWx    = CHR$(120)
       LWy    = CHR$(121)
       LWz     = CHR$(122)


 IF Nt4OrNewer() THEN
   hDevice = CreateFile("\\.\" + LWp + LWh + LWy + LWs + LWi + LWc + LWa + _
                 LWl + LWd + LWr + LWi + LWv + LWe  & TRIM$(STR$(DriveNumber)), _
                        %GENERIC_READ OR %GENERIC_WRITE, %FILE_SHARE_READ OR _
                        %FILE_SHARE_WRITE, BYVAL 0&, %OPEN_EXISTING, 0&, 0&)
 ELSE
   hDevice = CreateFile("\\.\" + LWs + LWm + LWa + LWr + LWt + LWv + LWs + LWd,_
         0&, 0&, BYVAL 0&, %CREATE_NEW, 0&, 0&)
 END IF

 FUNCTION = hDevice

END FUNCTION


'______________________________________________________________________________

FUNCTION IdentifyDrive(BYVAL hDrive AS LONG, BYVAL idCmd AS BYTE, _
                       BYVAL DriveNumber AS BYTE, DriveInf AS DRIVE_INFO) AS LONG
 'Function: Send an IDENTIFY command to the drive
 LOCAL SendCmdIn                        AS SENDCMDINPARAMS
 DIM   ByteArray(%OUTPUT_DATA_SIZE - 1) AS BYTE
 LOCAL BytesReturned                    AS LONG
 LOCAL Looper                           AS LONG

 SendCmdIn.cBufferSize                  = %IDENTIFY_BUFFER_SIZE
 SendCmdIn.bDriveNumber                 = DriveNumber
 SendCmdIn.irDriveRegs.bFeaturesReg     = 0
 SendCmdIn.irDriveRegs.bSectorCountReg  = 1
 SendCmdIn.irDriveRegs.bSectorNumberReg = 1
 SendCmdIn.irDriveRegs.bCylLowReg       = 0
 SendCmdIn.irDriveRegs.bCylHighReg      = 0
 SendCmdIn.irDriveRegs.bDriveHeadReg    = &HA0

 IF Nt4OrNewer = %FALSE THEN
   SendCmdIn.irDriveRegs.bDriveHeadReg = SendCmdIn.irDriveRegs.bDriveHeadReg OR ((DriveNumber AND 1) * 16)
 END IF

 'The command can either be IDE identify or ATAPI identify.
 SendCmdIn.irDriveRegs.bCommandReg = idCmd
 IF DeviceIoControl(hDrive, %DFP_RECEIVE_DRIVE_DATA, BYVAL VARPTR(SendCmdIn), SIZEOF(SendCmdIn) - 1, _
                    BYVAL VARPTR(ByteArray(0)), %OUTPUT_DATA_SIZE, BytesReturned, BYVAL 0&) THEN

   FOR Looper = 0 TO 38 STEP 2 'Model
     DriveInf.Model(Looper)     = ByteArray(Looper + 71)
     DriveInf.Model(Looper + 1) = ByteArray(Looper + 70)
   NEXT

   FOR Looper = 0 TO 18 STEP 2 'Serial
     DriveInf.SerialNumber(Looper)     = ByteArray(Looper + 37)
     DriveInf.SerialNumber(Looper + 1) = ByteArray(Looper + 36)
   NEXT

   FUNCTION = %TRUE

 END IF

END FUNCTION




 '______________________________________________________________________________

FUNCTION GetDriveSerial() AS STRING
 ' Obtain the Harddrive Serial numbers
 LOCAL DriveInf             AS DRIVE_INFO
 LOCAL pAsciiz              AS ASCIIZ POINTER
 LOCAL sSerialNumber        AS STRING
 LOCAL sSerialNumberEncoded AS STRING

 LOCAL sInterfaceType       AS STRING
 LOCAL sBuffer              AS STRING
 LOCAL hr                   AS DWORD
 LOCAL pCollection          AS DWORD
 LOCAL pEnum                AS DWORD
 LOCAL DriveNumber          AS BYTE
 LOCAL COUNT                AS LONG
 LOCAL SerialLen            AS LONG
 LOCAL RetVal               AS LONG
 LOCAL Looper               AS LONG
 LOCAL oLocator             AS DISPATCH
 LOCAL oServices            AS DISPATCH
 LOCAL oItem                AS DISPATCH
 LOCAL vServer              AS VARIANT
 LOCAL vVar                 AS VARIANT
 LOCAL vVarst              AS STRING

 LOCAL vRes                 AS VARIANT

        BSpc = CHR$(32)
        scomma = CHR$(44)
        suscore = CHR$(95)



       LWa   = CHR$(97)
       LWb    = CHR$(98)
       LWc    = CHR$(99)
       LWd    = CHR$(100)
       LWe   = CHR$(101)
       LWf     = CHR$(102)
       LWg    = CHR$(103)
       LWh    = CHR$(104)
       LWi    = CHR$(105)
       LWj    = CHR$(106)
       LWk    = CHR$(107)
       LWl     = CHR$(108)

       LWm    = CHR$(109)
       LWn     = CHR$(110)
       LWo     = CHR$(111)
       LWp     = CHR$(112)
       LWq     = CHR$(113)
       LWr     = CHR$(114)

       LWs    = CHR$(115)
       LWt     = CHR$(116)
       LWu    = CHR$(117)
       LWv    = CHR$(118)
       LWw   = CHR$(119)
       LWx    = CHR$(120)
       LWy    = CHR$(121)
       LWz     = CHR$(122)


 IF VistaOrNewer THEN

   'http://www.powerbasic.com/support/pbforums/showpost.php?p=391287&postcount=10
   #IF ((%DEF(%PB_WIN32)) AND (%PB_REVISION < &H1000)) OR ((%DEF(%PB_CC32)) AND (%PB_REVISION < &H0600))
     SET oLocator = NEW DISPATCH IN "WbemScripting.SWbemLocator"
   #ELSE
     LET oLocator = NEWCOM "WbemScripting.SWbemLocator"
   #ENDIF

   IF (ISOBJECT(oLocator)) THEN
     vServer = "."
     OBJECT CALL oLocator.ConnectServer(vServer) TO vRes
     SET oServices = vRes

      ' obtain the expression "SELECT  SerialNumber, InterfaceType FROM Win32_DiskDrive"
      vVarst =   LWs +  LWe +  LWl +  LWe +  LWc +  LWt + BSpc + LWs + LWe + _
             LWr +  LWi +   LWa +  LWl +  LWn
      vVarst =  vVarst +  LWu +  LWm +    LWb +   LWe +  LWr + scomma + _
                 BSPc + LWI + LWn + LWt +  LWe + LWr + _
                 LWf +  LWa + LWc + LWe + LWt  + LWy  + LWp + LWe
      vVarst =  vVarst + BSpc +  LWf +  LWr +    LWo +   LWm  + BSPc + _
                LWw + LWi + LWn + "32" + suscore + _
                LWd + LWi + LWs + LWk   + LWd    + LWr   + LWi + LWv   + LWe

     ' Set the string expression vVarst to variant
      LET vVar = vVarst AS WSTRING




     OBJECT CALL oServices.ExecQuery(vVar) TO vRes
     pCollection = VARIANT#(vRes)
     COUNT = WbemCollection_Count(pCollection)
     IF COUNT THEN
       pEnum = WbemCollection_NewEnum(pCollection)
       IF pEnum THEN
         DIM vArray(1 TO COUNT) AS VARIANT
         IF(WbemCollection_Enumerate(pEnum, vArray())) THEN
           hr = WbemCollection_Release(pCollection)
           FOR DriveNumber = 1 TO COUNT
             SET oItem = vArray(DriveNumber)
             IF OBJRESULT = %S_OK THEN

               vRes = EMPTY
               OBJECT GET oItem.InterfaceType TO vRes
               IF OBJRESULT = %S_OK THEN

                 sInterfaceType = VARIANT$(vRes)
                 IF (sInterfaceType <> "USB") AND (sInterfaceType <> "1394") THEN
                      'Could be SCSI, HDC, IDE, USB, 1394

                   vRes = EMPTY
                   OBJECT GET oItem.SerialNumber TO vRes
                   IF OBJRESULT = %S_OK THEN
                     sSerialNumberEncoded = TRIM$(VARIANT$(vRes))
                     SerialLen = LEN(sSerialNumberEncoded)
                     IF (SerialLen = LEN(RETAIN$(sSerialNumberEncoded, _
                        ANY "0123456789ABCDEFabcdef"))) AND _
                        (SerialLen >= 4) AND (SerialLen MOD 4 = 0) THEN
                        'Serial is ascii inversed paired hex byte.
                         sSerialNumber = ""
                         pAsciiz = STRPTR(sSerialNumberEncoded)
                       FOR Looper = 1 TO LEN(sSerialNumberEncoded) - 3 STEP 4
                         sSerialNumber = sSerialNumber & _
                         CHR$(VAL("&H" & MID$(@pAsciiz, Looper + 2, 2))) & _
                         CHR$(VAL("&H" & MID$(@pAsciiz, Looper, 2)))
                       NEXT
                       sBuffer = sBuffer &  TRIM$(sSerialNumber) & $CRLF & $CRLF
                     ELSE
                       sSerialNumberEncoded = REMOVE$(sSerialNumberEncoded, ANY $NUL)
                       sBuffer = sBuffer &  sSerialNumberEncoded & $CRLF & $CRLF
                     END IF
                   END IF
                 END IF
               END IF
               SET oItem = NOTHING
             END IF
           NEXT
         END IF
       END IF
     END IF
     SET oServices = NOTHING
     SET oLocator = NOTHING
     FUNCTION = sBuffer
   END IF

 ELSE 'XP or older

   FOR DriveNumber = 0 TO 7
     RetVal = GetDriveInfoXP(DriveNumber, DriveInf)
     IF RetVal THEN

       sSerialNumber = ""
       FOR Looper = 0 TO 19
         sSerialNumber = sSerialNumber & CHR$(DriveInf.SerialNumber(Looper))
       NEXT
       sSerialNumber = TRIM$(sSerialNumber)
       sSerialNumber = REMOVE$(sSerialNumber, ANY $NUL)
       IF LEN(sSerialNumber) THEN
         sBuffer = sBuffer &  TRIM$(sSerialNumber) & $CRLF & $CRLF
       END IF
     END IF
   NEXT
   FUNCTION = sBuffer

 END IF

END FUNCTION










'__________________________
FUNCTION AdaptersInfoGet()AS STRING

 LOCAL IpAddressPointer  AS IP_ADDR_STRING POINTER
 LOCAL pAdapter          AS IP_ADAPTER_INF POINTER
 LOCAL sBuffer           AS STRING
 LOCAL sAdapterBuffer    AS STRING
 LOCAL AdapterBufferSize AS DWORD
 LOCAL Looper            AS LONG
 LOCAL AdaptorIndex      AS LONG

 IF GetAdaptersInfo(BYVAL 0, AdapterBufferSize) = %ERROR_BUFFER_OVERFLOW THEN
   sAdapterBuffer = NUL$(AdapterBufferSize)
   pAdapter       = STRPTR(sAdapterBuffer)

   IF GetAdaptersInfo(BYVAL pAdapter, AdapterBufferSize) = %ERROR_SUCCESS THEN
     DO 'For each adaptor
       INCR AdaptorIndex
       sBuffer = $CRLF & _
                 "D:"  & RIGHT$(STR$(AdaptorIndex),1) & _
                    RTRIM$(@pAdapter.Description, $NUL) & $CRLF & _
                 "M:"  & RIGHT$(STR$(AdaptorIndex),1)
       'Build MAC address - Media Access Control
       FOR Looper = 0 TO @pAdapter.AddressLength - 1
           sBuffer = sBuffer & LCASE$(HEX$(@pAdapter.Address(Looper), 2)) & _
                    IIF$(Looper < @pAdapter.AddressLength - 1, "-", "")
       NEXT
       sBuffer = sBuffer & $CRLF &  "N:" & RIGHT$(STR$(AdaptorIndex),1) & _
                 RTRIM$(@pAdapter.AdapterName, $NUL)

      pAdapter = @pAdapter.pNext
     LOOP WHILE pAdapter
     FUNCTION = sBuffer
   END IF

 END IF

END FUNCTION









'______________________________________________________________________________

FUNCTION WbemCollection_Enumerate(BYVAL pThis AS DWORD, BYREF vArray() AS VARIANT) AS LONG
 LOCAL IID_IEnumVariant AS GUID
 LOCAL HRESULT AS DWORD
 LOCAL pIEnumVARIANT AS DWORD
 LOCAL celtFetched AS DWORD
 LOCAL vRes AS VARIANT
 LOCAL idx AS LONG

 IID_IEnumVARIANT = GUID$("{00020404-0000-0000-c000-000000000046}")
 IF pThis THEN
   IF UBOUND(vArray) <> -1 THEN 'Array dimensioned
     'See if the interface is supported
     HRESULT = IEnumVARIANT_QueryInterface(pThis, IID_IEnumVARIANT, VARPTR(pIEnumVARIANT))
       IF HRESULT = %S_OK THEN
       'Position the enumerator at the beginning of the list of elements
       HRESULT = IEnumVARIANT_Reset(pIEnumVARIANT)
       IF HRESULT <> %S_OK THEN
          IEnumVARIANT_Release pIEnumVARIANT
       ELSE
         'Fill the array
         idx = LBOUND(vArray)
         DO
           HRESULT = IEnumVARIANT_Next(pIEnumVARIANT, 1, vRes, celtFetched)
           IF HRESULT <> %S_OK OR celtFetched < 1 THEN EXIT DO
           vArray(idx) = vRes
           INCR idx
           IF idx > UBOUND(vArray) THEN EXIT DO
         LOOP
         'Release the interface
         HRESULT = IEnumVARIANT_Release(pIEnumVARIANT)
         FUNCTION = -1
       END IF
     END IF
   END IF
 END IF
END FUNCTION



 DECLARE FUNCTION IsWow64Process(BYVAL hProcess AS DWORD, BYREF Wow64Process AS LONG) AS LONG
'______________________________________________________________________________

DECLARE FUNCTION Template_IEnumVARIANT_QueryInterface(BYVAL pThis AS DWORD,_
      BYREF riid AS GUID, BYVAL ppvObj AS DWORD) AS DWORD
FUNCTION IEnumVARIANT_QueryInterface(BYVAL pThis AS DWORD, _
     BYREF riid AS GUID, BYVAL ppvObj AS DWORD) AS DWORD
 LOCAL HRESULT AS DWORD, ppthis AS DWORD PTR, pvtbl AS DWORD PTR
 LOCAL ppmethod AS DWORD PTR, pmethod AS DWORD
 ppthis = pThis
  pvtbl = @ppthis
  ppmethod = pvtbl
  pmethod = @ppmethod
 CALL DWORD pmethod USING Template_IEnumVARIANT_QueryInterface(pThis, riid, ppvObj) TO HRESULT
 FUNCTION = HRESULT
END FUNCTION



'______________________________________________________________________________

DECLARE FUNCTION Template_IEnumVARIANT_Release(BYVAL pThis AS DWORD) AS DWORD
FUNCTION IEnumVARIANT_Release(BYVAL pThis AS DWORD) AS DWORD
 LOCAL HRESULT AS DWORD, ppthis AS DWORD PTR, pvtbl AS DWORD PTR
 LOCAL ppmethod AS DWORD PTR, pmethod AS DWORD
 ppthis = pThis : pvtbl = @ppthis : ppmethod = pvtbl + 8 : pmethod = @ppmethod
 CALL DWORD pmethod USING Template_IEnumVARIANT_Release(pThis) TO HRESULT
 FUNCTION = HRESULT
END FUNCTION
'______________________________________________________________________________

DECLARE FUNCTION Template_IEnumVARIANT_Next(BYVAL pThis AS DWORD, _
 BYVAL celt AS DWORD, BYREF rgelt AS VARIANT, BYREF pceltFetched AS DWORD) AS DWORD
FUNCTION IEnumVARIANT_Next(BYVAL pThis AS DWORD, BYVAL celt AS DWORD, _
     BYREF rgelt AS VARIANT, BYREF pceltFetched AS DWORD) AS DWORD
 LOCAL HRESULT AS DWORD, ppthis AS DWORD PTR, pvtbl AS DWORD PTR
 LOCAL ppmethod AS DWORD PTR, pmethod AS DWORD
 ppthis = pThis : pvtbl = @ppthis : ppmethod = pvtbl + 12 : pmethod = @ppmethod
 CALL DWORD pmethod USING Template_IEnumVARIANT_Next(pThis,celt,rgelt,pceltFetched) TO HRESULT
 FUNCTION = HRESULT
END FUNCTION
'______________________________________________________________________________

DECLARE FUNCTION Template_IEnumVARIANT_Reset(BYVAL pThis AS DWORD) AS DWORD
FUNCTION IEnumVARIANT_Reset(BYVAL pThis AS DWORD) AS DWORD
 LOCAL HRESULT AS DWORD, ppthis AS DWORD PTR, pvtbl AS DWORD PTR
 LOCAL ppmethod AS DWORD PTR, pmethod AS DWORD
 ppthis = pThis : pvtbl = @ppthis : ppmethod = pvtbl + 20 : pmethod = @ppmethod
 CALL DWORD pmethod USING Template_IEnumVARIANT_Reset(pThis) TO HRESULT
 FUNCTION = HRESULT
END FUNCTION
'______________________________________________________________________________

DECLARE FUNCTION Template_WbemCollection_Release(BYVAL pThis AS DWORD) AS DWORD
FUNCTION WbemCollection_Release(BYVAL pThis AS DWORD) AS DWORD
 LOCAL HRESULT AS DWORD, ppthis AS DWORD PTR, pvtbl AS DWORD PTR
 LOCAL ppmethod AS DWORD PTR, pmethod AS DWORD
 ppthis = pThis : pvtbl = @ppthis : ppmethod = pvtbl + 8 : pmethod = @ppmethod
 CALL DWORD pmethod USING Template_WbemCollection_Release(pThis) TO HRESULT
 FUNCTION = HRESULT
END FUNCTION
'______________________________________________________________________________

DECLARE FUNCTION Proto_WbemCollection_NewEnum(BYVAL pThis AS DWORD, BYREF pEnum AS DWORD) AS DWORD
FUNCTION WbemCollection_NewEnum(BYVAL pThis AS DWORD) AS DWORD
 LOCAL HRESULT AS DWORD, ppthis AS DWORD PTR, pvtbl AS DWORD PTR
 LOCAL ppmethod AS DWORD PTR, pmethod AS DWORD, penum AS DWORD
 ppthis = pThis : pvtbl = @ppthis : ppmethod = pvtbl + 28 : pmethod = @ppmethod
 CALL DWORD pmethod USING Proto_WbemCollection_NewEnum(pThis, pEnum) TO HRESULT
 FUNCTION = pEnum
END FUNCTION
'______________________________________________________________________________

DECLARE FUNCTION Proto_WbemCollection_Count(BYVAL pThis AS DWORD, BYREF COUNT AS LONG) AS DWORD
FUNCTION WbemCollection_Count(BYVAL pThis AS DWORD) AS LONG
 LOCAL HRESULT AS DWORD, ppthis AS DWORD PTR, pvtbl AS DWORD PTR
 LOCAL ppmethod AS DWORD PTR, pmethod AS DWORD, COUNT AS LONG
 ppthis = pThis : pvtbl = @ppthis : ppmethod = pvtbl + 36 : pmethod = @ppmethod
 CALL DWORD pmethod USING Proto_WbemCollection_Count(pThis, COUNT) TO HRESULT
 FUNCTION = COUNT
END FUNCTION


'______________________________________________________________________________

FUNCTION MotherInfo() AS STRING
 '  To obtain the Mainboard data
 LOCAL oLocator    AS DISPATCH
 LOCAL oServices   AS DISPATCH
 LOCAL oItem       AS DISPATCH
 LOCAL vServer     AS VARIANT
 LOCAL vVarst        AS STRING
  LOCAL vVar        AS VARIANT


 LOCAL vRes        AS VARIANT
 LOCAL sBuffer     AS STRING
 LOCAL hr          AS DWORD
 LOCAL pCollection AS DWORD
 LOCAL pEnum       AS DWORD
 LOCAL i           AS LONG
 LOCAL COUNT      AS LONG

        BSpc = CHR$(32)
        scomma = CHR$(44)
        suscore = CHR$(95)



       LWa   = CHR$(97)
       LWb    = CHR$(98)
       LWc    = CHR$(99)
       LWd    = CHR$(100)
       LWe   = CHR$(101)
       LWf     = CHR$(102)
       LWg    = CHR$(103)
       LWh    = CHR$(104)
       LWi    = CHR$(105)
       LWj    = CHR$(106)
       LWk    = CHR$(107)
       LWl     = CHR$(108)

       LWm    = CHR$(109)
       LWn     = CHR$(110)
       LWo     = CHR$(111)
       LWp     = CHR$(112)
       LWq     = CHR$(113)
       LWr     = CHR$(114)

       LWs    = CHR$(115)
       LWt     = CHR$(116)
       LWu    = CHR$(117)
       LWv    = CHR$(118)
       LWw   = CHR$(119)
       LWx    = CHR$(120)
       LWy    = CHR$(121)
       LWz     = CHR$(122)






 #IF ((%DEF(%PB_WIN32)) AND (%PB_REVISION < &H1000)) OR ((%DEF(%PB_CC32)) AND (%PB_REVISION < &H0600))
   SET oLocator = NEW DISPATCH IN "WbemScripting.SWbemLocator"
 #ELSE
   LET oLocator = NEWCOM "WbemScripting.SWbemLocator"
 #ENDIF

 IF ISOBJECT(oLocator) THEN
   vServer = "." : OBJECT CALL oLocator.ConnectServer(vServer) TO vRes
   SET oServices = vRes

      ' obtain the expression "SELECT  Product, SerialNumber FROM Win32_BaseBoard"
      vVarst =   LWs +  LWe +  LWl +  LWe +  LWc +  LWt + BSpc + LWp + _
               LWr +   LWo +  LWd +   LWu +  LWc +  LWt + scomma
      vVarst =  vVarst +  LWs +  LWe +    LWr +   LWi +  LWa + LWl + LWn + _
                 LWu +  LWm + LWb +  LWe +  LWr + BSpc
      vVarst =  vVarst +  LWf +  LWr +    LWo +   LWm  + BSPc + LWw + LWi + _
                LWn + "32" + suscore +   LWb + LWa + LWs + LWe
      vVarst =  vVarst +  LWb +  LWo +    LWa +  LWr + LWd

     ' Set the string expression vVarst to variant
      LET vVar = vVarst AS WSTRING

   OBJECT CALL oServices.ExecQuery(vVar) TO vRes
   pCollection = VARIANT#(vRes)
   COUNT =  WbemCollection_Count(pCollection)
   IF COUNT THEN
     pEnum =  WbemCollection_NewEnum(pCollection)
     IF pEnum THEN
       DIM vArray(1 TO COUNT) AS VARIANT
       IF (WbemCollection_Enumerate(pEnum, vArray())) THEN
         hr = IEnumVARIANT_Release(pCollection)

         FOR i = 1 TO COUNT
           IF VARIANT#(vArray(i)) THEN
             SET oItem = vArray(i)
             IF OBJRESULT THEN EXIT FOR


             vRes = EMPTY
             OBJECT GET oItem.Product TO vRes
             sBuffer =  "N:"  & VARIANT$(vRes) & $CRLF

             vRes = EMPTY
             OBJECT GET oItem.SerialNumber TO vRes
             sBuffer = sBuffer  & " S:"  & VARIANT$(vRes) & $CRLF

             SET oItem = NOTHING

             FUNCTION = sBuffer

           END IF
         NEXT


       END IF
     END IF
   END IF
   SET oServices = NOTHING
   SET oLocator = NOTHING

 END IF

END FUNCTION


'______________________________________________________________________________

FUNCTION BiosInfo() AS STRING
'  To obtain the Bios information
 LOCAL oLocator             AS DISPATCH
 LOCAL oServices            AS DISPATCH
 LOCAL oItem                AS DISPATCH
 LOCAL vServer              AS VARIANT
 LOCAL vVar                 AS VARIANT
 LOCAL vVarst               AS STRING

 LOCAL vRes                 AS VARIANT
 LOCAL sBuffer              AS STRING
 LOCAL hr                   AS DWORD
 LOCAL pCollection          AS DWORD
 LOCAL pEnum                AS DWORD
 LOCAL i                    AS LONG
 LOCAL COUNT               AS LONG


        BSpc = CHR$(32)
        scomma = CHR$(44)
        suscore = CHR$(95)

       LWa   = CHR$(97)
       LWb    = CHR$(98)
       LWc    = CHR$(99)
       LWd    = CHR$(100)
       LWe   = CHR$(101)
       LWf     = CHR$(102)
       LWg    = CHR$(103)
       LWh    = CHR$(104)
       LWi    = CHR$(105)
       LWj    = CHR$(106)
       LWk    = CHR$(107)
       LWl     = CHR$(108)

       LWm    = CHR$(109)
       LWn     = CHR$(110)
       LWo     = CHR$(111)
       LWp     = CHR$(112)
       LWq     = CHR$(113)
       LWr     = CHR$(114)

       LWs    = CHR$(115)
       LWt     = CHR$(116)
       LWu    = CHR$(117)
       LWv    = CHR$(118)
       LWw   = CHR$(119)
       LWx    = CHR$(120)
       LWy    = CHR$(121)
       LWz     = CHR$(122)


 #IF ((%DEF(%PB_WIN32)) AND (%PB_REVISION < &H1000)) OR ((%DEF(%PB_CC32)) AND (%PB_REVISION < &H0600))
   SET oLocator = NEW DISPATCH IN "WbemScripting.SWbemLocator"
 #ELSE
   LET oLocator = NEWCOM "WbemScripting.SWbemLocator"
 #ENDIF

 IF ISOBJECT(oLocator) THEN
   vServer = "." : OBJECT CALL oLocator.ConnectServer(vServer) TO vRes
   SET oServices = vRes

     ' obtain the expression "SELECT * FROM Win32_BIOS"
      vVarst =   LWs +  LWe +  LWl +  LWe +  LWc +  LWt + BSpc + "* "
      vVarst =  vVarst +  LWf +  LWr +    LWo +   LWm  + BSPc + LWw + LWi + LWn + _
               "32" + suscore +   LWb + LWi + LWo + LWs

     ' Set the string expression vVarst to variant
      LET vVar = vVarst AS WSTRING




   OBJECT CALL oServices.ExecQuery(vVar) TO vRes
   pCollection = VARIANT#(vRes)
   COUNT =  WbemCollection_Count(pCollection)
   IF COUNT THEN
     pEnum =  WbemCollection_NewEnum(pCollection)
     IF pEnum THEN
       DIM vArray(1 TO COUNT) AS VARIANT
       IF (WbemCollection_Enumerate(pEnum, vArray())) THEN
         hr = IEnumVARIANT_Release(pCollection)
         FOR i = 1 TO COUNT
           IF VARIANT#(vArray(i)) THEN
             SET oItem = vArray(i)
             IF OBJRESULT THEN EXIT FOR

              vRes = EMPTY
             OBJECT GET oItem.ReleaseDate TO vRes
             sBuffer = sBuffer & $TAB & "R:"  & LEFT$(VARIANT$(vRes), 4) & "-" & _
                       MID$(VARIANT$(vRes), 5, 2) & "-" & _
                       MID$(VARIANT$(vRes), 7, 2) & $CRLF

             vRes = EMPTY
             OBJECT GET oItem.SMBIOSBIOSVersion TO vRes
             sBuffer = sBuffer & $TAB & " B:"  & VARIANT$(vRes) & $CRLF


             SET oItem = NOTHING
             FUNCTION = sBuffer
           END IF
         NEXT
       END IF
     END IF
   END IF
   SET oServices = NOTHING
   SET oLocator = NOTHING
 END IF

END FUNCTION
